from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

if TYPE_CHECKING:
    from ..models.dataset_post_entries_entries_item import DatasetPostEntriesEntriesItem


T = TypeVar("T", bound="DatasetPostEntries")


@_attrs_define
class DatasetPostEntries:
    """
    Attributes:
        entries (list['DatasetPostEntriesEntriesItem']):  Example: [{'input': 'hi', 'output': 'Hello, how can I help you
            today?'}].
    """

    entries: list["DatasetPostEntriesEntriesItem"]
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        entries = []
        for entries_item_data in self.entries:
            entries_item = entries_item_data.to_dict()
            entries.append(entries_item)

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "entries": entries,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.dataset_post_entries_entries_item import DatasetPostEntriesEntriesItem

        d = dict(src_dict)
        entries = []
        _entries = d.pop("entries")
        for entries_item_data in _entries:
            entries_item = DatasetPostEntriesEntriesItem.from_dict(entries_item_data)

            entries.append(entries_item)

        dataset_post_entries = cls(
            entries=entries,
        )

        dataset_post_entries.additional_properties = d
        return dataset_post_entries

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
